<?php
include_once('cams.php');
?>
<html>
<head>
	<title>Yoshie WebCams - Animal farm (beta)</title>
	<script type="text/javascript" src="https://code.jquery.com/jquery-1.8.3.min.js"></script>
	<script type="text/javascript">
	function WebCam(pImageObj) {
		this.lWebcamObj				= null;
		this.lWebCamTimer 			= null;
		this.lWebCamFPS				= null;
		this.lWebCamImageObj 		= null;
		this.lWebCamTitle			= null;
		this.lWebCamUrl 			= null;
		this.lWebcamZoomLevel		= null;
		this.lWebCamMaxZoomLevel 	= null;
		this.lWebCamZoomStep		= null;

		this.lWebCamOriginalSizes	= null;
		this.lWebCamImageObjTop		= null;
		this.lWebCamImageObjLeft	= null;

		this.setup = function(pImageObj) {
			pImageObj			 		= jQuery(pImageObj);
			this.lWebCamUrl 			= pImageObj.attr('src') 	|| null;
			this.lWebCamTitle 			= pImageObj.attr('title') 	|| 'unknown cam';
			this.lWebcamZoomLevel 		= pImageObj.attr('zoom') 	|| 0;
			this.lWebCamFPS	 			= pImageObj.attr('fps') 	|| 1;
			this.lWebCamMaxZoomLevel	= 20;
			this.lWebCamZoomStep		= 10;

			this.lWebcamObj				= this._generateWebCamHTML();
			this.lWebCamImageObj		= this.lWebcamObj.find('img');

			this.lWebCamImageObjTop 	= 0;
			this.lWebCamImageObjLeft 	= 0;
			this.lWebCamOriginalSizes	= {	'width' : this.lWebCamImageObj.parent().innerWidth(),
											'height': this.lWebCamImageObj.parent().innerHeight()
										  };

			// Hover functionality for zoom buttons
			this.lWebcamObj.hover(
				function() {
					jQuery('.hover', this).fadeIn();
				},
				function() {
					jQuery('.hover', this).fadeOut();
				}
			);
			this.buttonsState();

			// Replace the original image with the WebCam version
			pImageObj.replaceWith(this.lWebcamObj);
			if (this.lWebCamUrl != null) this.stream();
		}

		this._generateWebCamHTML = function() {
			var lHTMLCodeObj = jQuery('<div/>', {'class': 'webcam'});
			lHTMLCodeObj.append(jQuery('<span/>', {'class': 'name'}).text(this.lWebCamTitle));

			var lZoomObj = jQuery('<div/>', {'class': 'zoom hover'});
			var self = this;
			jQuery.each(['in','out','up','left','reset','right','down'],function(key,index) {
				var lButtonObj = jQuery('<div/>',{'class' : 'button ' + index});
				lButtonObj.bind('click',function(){ if (jQuery(this).hasClass('active')) self.clickButton(jQuery(this).attr('class').replace('button','').replace('active','').trim());});
				lZoomObj.append(lButtonObj);
			});
			lHTMLCodeObj.append(lZoomObj);
			lHTMLCodeObj.append(jQuery('<img/>',{'title' : this.lWebCamTitle, 'src': this.lWebCamUrl}));
			return lHTMLCodeObj;
		}

		this.stream = function() {
			var self = this;
			this.lWebCamTimer = setInterval(function(){
				self.lWebCamImageObj.attr('src',self.lWebCamUrl + '&t=' + new Date().getTime());
			},(1/this.lWebCamFPS) * 1000);
		}

		this.buttonsState = function() {
			this.lWebcamObj.find('.button').removeClass('active');
			var self = this;

			this.lWebcamObj.find('.button').each(function() {
				var lActivate = false;
				switch(jQuery(this).attr('class').replace('button','').replace('active','').trim()) {
					case 'in':
						lActivate = (self.lWebcamZoomLevel < self.lWebCamMaxZoomLevel);
					break;
					case 'out':
					case 'reset':
						lActivate = (self.lWebcamZoomLevel > 0);
					break;
					case 'up':
						lActivate = (self.lWebCamImageObjTop < 0);
					break;
					case 'left':
						lActivate = (self.lWebCamImageObjLeft < 0);
					break;
					case 'right':
						lActivate = (Math.ceil(self.lWebCamImageObjLeft) > (-1 * Math.floor((self.lWebcamZoomLevel * (self.lWebCamOriginalSizes['width'] / self.lWebCamZoomStep)))));
					break;
					case 'down':
						lActivate = (Math.ceil(self.lWebCamImageObjTop) > (-1 * Math.floor((self.lWebcamZoomLevel * (self.lWebCamOriginalSizes['height'] / self.lWebCamZoomStep)))));
					break;
				}
				if (lActivate) jQuery(this).addClass('active');
			});
		}

		this.zoom = function(pButton) {
			var lWidth 	= this.lWebCamOriginalSizes['width'];
			var lHeight = this.lWebCamOriginalSizes['height'];
			var lTop 	= 0;
			var lLeft 	= 0;

			if (pButton == 'reset') {
				this.lWebcamZoomLevel = 0;
			} else if (
						(pButton == 'in' && this.lWebcamZoomLevel < 20) ||
						(pButton == 'out' && this.lWebcamZoomLevel > 0)
					) {
				var lDirection = (pButton == 'in' ? -1 : 1 );
				this.lWebcamZoomLevel = this.lWebcamZoomLevel + (-1 * lDirection);

				lWidth 	= this.lWebCamOriginalSizes['width'] 	+ (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['width']	/ this.lWebCamZoomStep));
				lHeight	= this.lWebCamOriginalSizes['height'] 	+ (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['height']	/ this.lWebCamZoomStep));
				lTop	= (this.lWebCamImageObj.position().top * 1) + (lDirection * (this.lWebCamOriginalSizes['height']		/ this.lWebCamZoomStep / 2));
				lLeft	= (this.lWebCamImageObj.position().left * 1)+ (lDirection * (this.lWebCamOriginalSizes['width']			/ this.lWebCamZoomStep / 2));

				if (lTop > 0) 	lTop  = 0;
				else if (lTop < -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['height'] / this.lWebCamZoomStep))) lTop = -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['height'] / this.lWebCamZoomStep));
				if (lLeft > 0) 	lLeft = 0;
				else if (lLeft < -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['width'] / this.lWebCamZoomStep))) lLeft = -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['width'] / this.lWebCamZoomStep));

			} else {
				return 0;
			}

			this.lWebCamImageObjTop = lTop;
			this.lWebCamImageObjLeft = lLeft;
			this.lWebCamImageObj.animate({
											width	: lWidth + 'px',
											height	: lHeight + 'px',
											top 	: lTop + 'px',
											left	: lLeft + 'px'
										},500);
		}

		this.move = function(pButton) {
			var lTop 	= 0;
			var lLeft 	= 0;

			if (this.lWebcamZoomLevel > 0) {
				var lDirection = (pButton == 'up' || pButton == 'left' ? 1 : -1 );
				if (pButton == 'up' || pButton == 'down') {
					lTop = (this.lWebCamImageObj.position().top * 1) + (lDirection * (this.lWebCamOriginalSizes['height'] / this.lWebCamZoomStep / 2));
					if (pButton == 'up' && lTop > 0) lTop = 0;
					if (pButton == 'down' 	&& lTop < -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['height'] / this.lWebCamZoomStep))) lTop = -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['height'] / this.lWebCamZoomStep));
					this.lWebCamImageObjTop = lTop;
					this.lWebCamImageObj.animate({top: lTop + 'px'},500);
				} else if (pButton == 'left' || pButton == 'right') {
					lLeft = (this.lWebCamImageObj.position().left * 1) + (lDirection * (this.lWebCamOriginalSizes['width'] / this.lWebCamZoomStep / 2));
					if (pButton == 'left' 	&& lLeft > 0) lLeft = 0;
					if (pButton == 'right'	&& lLeft < -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['width'] / this.lWebCamZoomStep))) lLeft = -1 * (this.lWebcamZoomLevel * (this.lWebCamOriginalSizes['width'] / this.lWebCamZoomStep));
					this.lWebCamImageObjLeft = lLeft;
					this.lWebCamImageObj.animate({left: lLeft + 'px'},500);
				}
			}
		}

		this.clickButton = function(pButton) {
			switch(pButton) {
				case 'in':
				case 'out':
				case 'reset':
					this.zoom(pButton);
				break;
				case 'up':
				case 'down':
				case 'left':
				case 'right':
					this.move(pButton);
				break;
			}
			this.buttonsState();
		}

		// Start the object
		this.setup(pImageObj);
	}

	// Find and initialize all the web cam images
	jQuery().ready(function() {
		jQuery('img.webcam').each(function() {
			new WebCam(this);
		});
	});
	</script>
	<style>
		.webcam {
			position: relative;
			font-family: Verdana;
			font-size: 10px;
			display: block;

			width: 512px;
			height: 384px;

			overflow: hidden;
			margin: 10px;
			float: left;
		}

		.webcam.focus {
			width: 640px;
			height: 480px;
			z-index: 99;
			position: absolute;
			top: 10px;
			left: 10px;
		}
		.webcam .name {
			font-size: 10px;
			font-weight: bold;
			background-color: black;
			color: white;
			z-index: 99;
			position: relative;
			float: right;
			padding: 1px 3px 0px 0px;
		}

		.webcam img {
			width: 100%;
			position: absolute;
			z-index: 1;
		}

		.webcam .zoom {
			position: absolute;
			right:10px;
			bottom: 10px;
			width: 93px;
			height: 64px;
			z-index: 99;
			border-radius: 5px 5px 5px 5px;
			background-color: black;
			opacity: 0.55;
		}

		.webcam .zoom .button {
			border-radius: 2px 2px 2px 2px;
			width: 20px;
			height: 20px;
			opacity: 0.65;
			background-color: white;
			background-repeat: no-repeat;
			background-image: url('images/icons.png');
			position: absolute;
		}

		.webcam .zoom .button.active {
			opacity: 1 !important;
			cursor: pointer !important;
		}

		.webcam .zoom .button.in {
			background-position: -15px 2px;
			top: 13px;
			left: 1px;
		}

		.webcam .zoom .button.out {
			background-position: -65px 2px;
			top: 34px;
			left: 1px;
		}

		.webcam .zoom .button.up {
			background-position: -265px 2px;
			top: 1px;
			left: 51px;
		}

		.webcam .zoom .button.left {
			background-position: -115px 2px;
			top: 22px;
			left: 30px;
		}

		.webcam .zoom .button.reset {
			background-position: -315px 2px;
			top: 22px;
			left: 51px;
		}

		.webcam .zoom .button.right {
			background-position: -165px 2px;
			top: 22px;
			left: 72px;
		}

		.webcam .zoom .button.down {
			background-position: -215px 2px;
			top: 43px;
			left: 51px;
		}
	</style>
</head>
<body>
<?php
foreach ($lWebCams as $lWebCamName => $lWebCam) {
	echo '<img src="stream.php?webcam=' . $lWebCamName . '" class="webcam" title="' . $lWebCamName . '" />';
}
?>
</body>
</html>
